//SPIT370T JOB (SYS),'TEST SPITBOL/370',CLASS=S,MSGCLASS=X              00010000
//SPIT370 PROC CORE=200K                                                00020000
//SPIT370 EXEC PGM=OSINT,REGION=&CORE                                   00030000
//STEPLIB  DD  DSN=SYSP.SPIT370.LOADMODS,DISP=SHR                       00040000
//SYSPRINT DD  SYSOUT=*,DCB=(LRECL=133,RECFM=FBA,BLKSIZE=1995)          00050000
//SYSPUNCH DD  SYSOUT=B,DCB=(LRECL=80,RECFM=FB,BLKSIZE=80)              00060000
//SYSUDUMP DD  SYSOUT=Y                                                 00070000
// PEND                                                                 00080000
// EXEC SPIT370                                                         00090000
//SYSIN    DD  *                                                        00100000
-TITLE SPITBOL TEST PROGRAM #3 -- COMPUTE FACTORIAL TABLE               00110000
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00120000
*                                                                     * 00130000
*        THIS PROGRAM COMPUTES AND PRINTS A TABLE OF N FACTORIAL      * 00140000
*        FOR VALUES OF N FROM 1 THROUGH AN UPPER LIMIT "NX".          * 00150000
*                                                                     * 00160000
*        IT DEMONSTRATES A METHOD OF MANIPULATING NUMBERS WHICH ARE   * 00170000
*        TOO LARGE FOR THE COMPUTER, AS STRINGS OF CHARACTERS.  THE   * 00180000
*        COMMAS IN THE PRINTED VALUES ARE OPTIONAL, ADDED FOR READING * 00190000
*        EASE.                                                        * 00200000
*                                                                     * 00210000
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00220000
*                                                                       00230000
*        INITIALIZATION.                                                00240000
*                                                                       00250000
         NX = 45                                                        00260000
         N = 1                                                          00270000
         NSET = 1                                                       00280000
         NUM = ARRAY(1000)                                              00290000
         NUM<1> = 1                                                     00300000
         FILL = ARRAY('0:3')                                            00310000
         FILL<0> = '000'                                                00320000
         FILL<1> = '00'                                                 00330000
         FILL<2> = '0'                                                  00340000
*                                                                       00350000
         OUTPUT = '          TABLE OF FACTORIALS FOR 1 THROUGH ' NX     00360000
         OUTPUT =                                                       00370000
*                                                                       00380000
*        COMPUTE THE NEXT VALUE FROM THE PREVIOUS ONE.                  00390000
*                                                                       00400000
L1       I = 1                                                          00410000
L2       NUM<I> = NUM<I> * N                           :F(ERR)          00420000
         I = LT(I,NSET) I + 1                          :S(L2)           00430000
         I = 1                                                          00440000
L3       LT(NUM<I>,1000)                               :S(L4)           00450000
         NUMX = NUM<I> / 1000                          :F(ERR)          00460000
         NUM<I + 1> = NUM<I + 1> + NUMX                :F(ERR)          00470000
         NUM<I> = NUM<I> - 1000 * NUMX                 :F(ERR)          00480000
L4       I = LT(I,NSET) I + 1                          :S(L3)           00490000
*                                                                       00500000
*        FORM A STRING REPRESENTING THE FACTORIAL.                      00510000
*                                                                       00520000
L5       NSET = DIFFER(NUM<NSET + 1>) NSET + 1                          00530000
         NUMBER = NUM<NSET>                            :F(ERR)          00540000
         I = GT(NSET,1) NSET - 1                       :F(L7)           00550000
L6       NUMBER = NUMBER ',' FILL<SIZE(NUM<I>)> NUM<I>                  00560000
         I = GT(I,1) I - 1                             :S(L6)           00570000
*                                                                       00580000
*        OUTPUT A LINE OF THE TABLE.                                    00590000
*                                                                       00600000
L7       OUTPUT = N '!=' NUMBER                                         00610000
         N = LT(N,NX) N + 1                            :S(L1)F(END)     00620000
*                                                                       00630000
*        ERROR TERMINATION.                                             00640000
*                                                                       00650000
ERR      OUTPUT = N '! CANNOT BE COMPUTED BECAUSE OF TABLE OVERFLOW.'   00660000
         OUTPUT = '     INCREASE THE SIZE OF ARRAY "NUM".'              00670000
*                                                                       00680000
END                                                                     00690000
./*                                                                     00700000
-TITLE SPITBOL TEST PROGRAM #5 -- DEMONSTRATION VERSION OF TREESORT4    00710000
-STITL DRIVER                                                           00720000
 DEFINE('TREESORT4(DATA,NUMBER_TO_SORT)')                               00730000
 DEFINE('PRINTER()')                                                    00740000
 DATA = ARRAY(24)                                                       00750000
         INPUT(.INPUT,,72)                                              00760000
READER J = J + 1                                                        00770000
 DATA<J> = TRIM(INPUT)  :S(READER)                                      00780000
 OUTPUT = 'UNSORTED DATA'                                               00790000
 OUTPUT =                                                               00800000
 PRINTER()                                                              00810000
 TREESORT4(DATA,24)                                                     00820000
 OUTPUT =                                                               00830000
 OUTPUT = 'SORTED DATA'                                                 00840000
 OUTPUT =                                                               00850000
 PRINTER() :(END)                                                       00860000
*                                                                       00870000
PRINTER J = 0                                                           00880000
PRINTL J = J + 1                                                        00890000
 OUTPUT = DATA<J>    :S(PRINTL)F(RETURN)                                00900000
-STITL ACTUAL TREESORT4 SUBROUTINE                                      00910000
*             TREESORT4                                                 00920000
*             ---------                                                 00930000
*                                                                       00940000
*             SORTING ALGORITHM DERIVED FROM FLOYD'S TREESORT3 PUBLISHED00950000
*             IN CACM DEC. 1967 -- THE MODIFICATIONS DEVISED BY R. DEWAR00960000
*             AND L.FISHER REDUCE THE NUMBER OF COMPARES FROM 2NLOGN    00970000
*             TO NLOGN -- THIS VERSION CODED IN SNOBOL4 BY R. DEWAR     00980000
*                                                                       00990000
TREESORT4                                                               01000000
.             NUMBER_IN_TREE = NUMBER_TO_SORT                           01010000
              NODE_TO_SIFT = NUMBER_TO_SORT / 2                         01020000
              RETURN_FROM_SIFT = .SIFT_RETURN_1                         01030000
SIFT_CALL_1                                                             01040000
.             HOLD_LOCATION = DATA<NODE_TO_SIFT> :(SIFT_NODE)           01050000
SIFT_RETURN_1                                                           01060000
.             NODE_TO_SIFT = GT(NODE_TO_SIFT,1)                         01070000
.                              NODE_TO_SIFT - 1  :S(SIFT_CALL_1)        01080000
SECOND_PHASE                                                            01090000
.             RETURN_FROM_SIFT = .SIFT_RETURN_2                         01100000
SIFT_RETURN_2                                                           01110000
.             HOLD_LOCATION = DATA<NUMBER_IN_TREE>                      01120000
              DATA<NUMBER_IN_TREE> = DATA<1>                            01130000
              NUMBER_IN_TREE = GT(NUMBER_IN_TREE,1)                     01140000
.                               NUMBER_IN_TREE - 1                      01150000
.                                                :S(SIFT_NODE)F(RETURN) 01160000
-EJECT                                                                  01170000
SIFT_NODE                                                               01180000
.             FATHER = NODE_TO_SIFT                                     01190000
PULL_UP_LARGER_SON                                                      01200000
.             LEFT_SON = FATHER * 2                                     01210000
              LT(LEFT_SON,NUMBER_IN_TREE)        :S(COMPARE_SONS)       01220000
              EQ(LEFT_SON,NUMBER_IN_TREE)        :S(LEFT_SON_HIGH)      01230000
                                                 :(CHECK_FATHERS)       01240000
COMPARE_SONS                                                            01250000
.             RIGHT_SON = LEFT_SON + 1                                  01260000
              LGT(DATA<LEFT_SON>,DATA<RIGHT_SON>)                       01270000
.                                                :S(LEFT_SON_HIGH)      01280000
RIGHT_SON_HIGH                                                          01290000
.             DATA<FATHER> = DATA<RIGHT_SON>                            01300000
              FATHER = RIGHT_SON                 :(PULL_UP_LARGER_SON)  01310000
LEFT_SON_HIGH                                                           01320000
.             DATA<FATHER> = DATA<LEFT_SON>                             01330000
              FATHER = LEFT_SON                  :(PULL_UP_LARGER_SON)  01340000
CHECK_FATHERS                                                           01350000
.             HOLE_IN_TREE = FATHER                                     01360000
TEST_NEXT_FATHER                                                        01370000
.             FATHER_OF_HOLE = HOLE_IN_TREE / 2                         01380000
              LT(FATHER_OF_HOLE,NODE_TO_SIFT)    :S(FILL_HOLE)          01390000
              LGT(DATA<FATHER_OF_HOLE>,HOLD_LOCATION)                   01400000
.                                                :S(FILL_HOLE)          01410000
              DATA<HOLE_IN_TREE> = DATA<FATHER_OF_HOLE>                 01420000
              HOLE_IN_TREE = FATHER_OF_HOLE      :(TEST_NEXT_FATHER)    01430000
FILL_HOLE                                                               01440000
.             DATA<HOLE_IN_TREE> = HOLD_LOCATION                        01450000
.                                                :($RETURN_FROM_SIFT)   01460000
END                                                                     01470000
SHALL                                                                   01480000
I                                                                       01490000
COMPARE                                                                 01500000
THEE                                                                    01510000
TO                                                                      01520000
A                                                                       01530000
SUMMERS                                                                 01540000
DAY                                                                     01550000
THOU                                                                    01560000
ART                                                                     01570000
MORE                                                                    01580000
LOVELY                                                                  01590000
AND                                                                     01600000
MORE                                                                    01610000
TEMPORATE                                                               01620000
ROUGH                                                                   01630000
WINDS                                                                   01640000
DO                                                                      01650000
SHAKE                                                                   01660000
THE                                                                     01670000
DARLING                                                                 01680000
BUDS                                                                    01690000
OF                                                                      01700000
MAY                                                                     01710000
./*                                                                     01720000
-TITLE SPITBOL TEST PROGRAM #6 -- TOPOLOGICAL SORT                      01730000
*                                                                       01740000
*        TOPOLOGICAL SORT                                               01750000
*                                                                       01760000
*   MAPS A PARTIAL ORDERING OF OBJECTS INTO A LINEAR ORDERING           01770000
*                                                                       01780000
*        A(1), A(2), ..., A(N)                                          01790000
*                                                                       01800000
*   SUCH THAT IF   A(S) < A(T) IN THE PARTIAL ORDERING,THEN S < T.      01810000
*   (CF. D.E.KNUTH, THE ART OF COMPUTER PROGRAMMING,VOLUME 1,           01820000
*   ADDISON-WESLEY,MASS.,1968, P.262)                                   01830000
*                                                                       01840000
         &DUMP = 2                                                      01850000
         OUTPUT('OUT',6,'(121A1)')                                      01860000
         PAIR      = BREAK('<') . MU LEN(1) BREAK(',') . NU LEN(1)      01870000
         DATA('ITEM(COUNT,TOP)')                                        01880000
         DATA('NODE(SUC,NEXT)')                                         01890000
         DEFINE('DECR(X)')                                              01900000
         DEFINE('INDEX(TAU)')                                           01910000
         INPUT(.INPUT,,72)                                              01920000
*                                                                       01930000
*     READ IN THE NUMBER OF ITEMS, N, AND GENERATE AN ARRAY OF ITEMS.   01940000
*                                                                       01950000
*   EACH ITEM HAS TWO FIELDS, (COUNT,TOP), WHERE                        01960000
*        COUNT = NO. OF ELEMENTS PRECEEDING IT.                         01970000
         TOP = TOP OF LIST OF ITEMS SUCCEEDING IT.                      01980000
*                                                                       01990000
         N         = TRIM(INPUT)                                        02000000
         X         = ARRAY('0:' N)                                      02010000
*   INITIALIZE THE ITEMS TO (0,NULL).                                   02020000
*                                                                       02030000
T1       X<I>      =  ITEM(0,)              :F(T1A)                     02040000
         I         =  I + 1                 :(T1)                       02050000
*                                                                       02060000
*   READ IN RELATIONS.                                                  02070000
*                                                                       02080000
T1A      OUT       = '1 THE RELATIONS ARE:'                             02090000
T2A      REL       = TRIM(INPUT) ','        :F(T3A)                     02100000
         OUTPUT    = REL                                                02110000
T2       REL       PAIR  =                  :F(T2A)                     02120000
         J         = INDEX(MU)                                          02130000
         K         = INDEX(NU)                                          02140000
*                                                                       02150000
*   SINCE MU < NU, INCREASE THE COUNT OF THE KTH ITEM AND ADD A         02160000
*   NODE TO THE LIST OF SUCCESSORS OF THE JTH ITEM.                     02170000
*                                                                       02180000
T3       COUNT(X<K>) = COUNT(X<K>) + 1                                  02190000
         TOP(X<J>) = NODE(K,TOP(X<J>))      :(T2)                       02200000
-EJECT                                                                  02210000
*                                                                       02220000
*    A QUEUE IS MAINTAINED OF THOSE ITEMS WITH ZERO COUNT FIELD.        02230000
*    THE LINKS FOR THE QUEUE, QLINK, ARE KEPT IN THE COUNT FIELD.       02240000
*    THE VARIABLES F,R POINT TO THE FRONT AND REAR OF THE QUEUE.        02250000
*                                                                       02260000
T3A      OPSYN('QLINK','COUNT')                                         02270000
*                                                                       02280000
*    INITIALIZE THE QUEUE FOR OUTPUT.                                   02290000
*                                                                       02300000
         R         = 0                                                  02310000
         QLINK(X<0>) = 0                                                02320000
         K         = 0                                                  02330000
T4       K         = ?X<K + 1>  K + 1       :F(T4A)                     02340000
         QLINK(X<R>) = EQ(COUNT(X<K>),0)  K :F(T4)                      02350000
         R         = K                      :(T4)                       02360000
T4A      F         = QLINK(X<0>)                                        02370000
*                                                                       02380000
*    OUTPUT THE FRONT OF THE QUEUE.                                     02390000
*                                                                       02400000
         OUT       = '0 THE LINEAR ORDERING IS:'                        02410000
T5       OUTPUT    = NE(F,0)  $(F ':')      :F(T8)                      02420000
         N         = N - 1                                              02430000
         P         = TOP(X<F>)                                          02440000
*    ERASE RELATIONS.                                                   02450000
T6       IDENT(P)                           :S(T7)                      02460000
         DECR(.COUNT(X<SUC(P)>))            :S(T6A)                     02470000
*                                                                       02480000
*    IF COUNT IS ZERO ADD  ITEM TO QUEUE.                               02490000
*                                                                       02500000
         QLINK(X<R>) = SUC(P)                                           02510000
         R         = SUC(P)                                             02520000
T6A      P         = NEXT(P)                :(T6)                       02530000
*                                                                       02540000
*    REMOVE FROM QUEUE.                                                 02550000
*                                                                       02560000
T7       F         = QLINK(X<F>)            :(T5)                       02570000
*                                                                       02580000
*    FUNCTION DEFINITIONS.                                              02590000
*                                                                       02600000
DECR     $X        = GT($X,1)  $X - 1       :S(RETURN)                  02610000
         $X        = 0                      :(FRETURN)                  02620000
*                                                                       02630000
INDEX    INDEX     = DIFFER($(TAU ':'))  $(TAU ':')  :S(RETURN)         02640000
         TERMCT    = LT(TERMCT,N)  TERMCT + 1    :F(FRETURN)            02650000
         INDEX     = TERMCT                                             02660000
         $(TERMCT ':')   =  TAU                                         02670000
         $(TAU ':')   =  TERMCT             :(RETURN)                   02680000
*                                                                       02690000
T8       OUTPUT    = NE(N,0) 'THE ORDERING CONTAINS A LOOP.'            02700000
END                                                                     02710000
14                                                                      02720000
LETTERS<ALPHANUM,NUMBERS<ALPHANUM                                       02730000
BLANKS<OPTBLANKS                                                        02740000
NUMBERS<REAL                                                            02750000
NUMBERS<INTEGER                                                         02760000
LETTERS<VARIABLE,ALPHANUM<VARIABLE                                      02770000
BINARY<BINARYOP,BLANKS<BINARYOP                                         02780000
UNQALPHABET<DLITERAL                                                    02790000
UNQALPHABET<SLITERAL                                                    02800000
SLITERAL<LITERAL,DLITERAL<LITERAL,INTEGER<LITERAL,REAL<LITERAL          02810000
./*                                                                     02820000
-TITLE SPITBOL TEST PROGRAM #7 -- SYMBOL TABLE GENERATOR                02830000
*                                                                       02840000
*        THIS PROGRAM DEMONSTRATES THE STORAGE OF SYMBOL TABLES         02850000
*        USING A TECHIQUE IN WHICH NAMES ARE STORED AS LINKED LISTS     02860000
*        OF CHARACTERS. THE DATA FUNCTION IS USED TO FORM THE           02870000
*        REQUIRED NODES WHICH CONTAIN APPROPRIATE POINTERS TO BE        02880000
*        USED ON FAILURE OR SUCCESS OF THE CHARACTER BY CHARACTER MATCH 02890000
*                                                                       02900000
-CODE                                                                   02910000
         DATA('SYMB(CHAR,LINK,ALT,ASSOC,SUCC)')                         02920000
         INPUT(.INPUT,,72)                                              02930000
         SPC = '     ::'                                                02940000
         ALPH = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"                            02950000
CLEAR    HEAD =                                                         02960000
         SWITCH1 = .FIRST                                               02970000
         X = 0                                                          02980000
READA    OUTPUT =                                                       02990000
READ     CARD = TRIM(INPUT)                      :F(END1)               03000000
         OUTPUT = CARD                                                  03010000
         DIFFER(CARD)                            :F(BADCARD)            03020000
         CARD POS(0) '$' =                       :S(CONTROL)            03030000
         CARD NOTANY(ALPH)                       :F(INCX)               03040000
BADCARD  OUTPUT = '  CARD ABOVE IS ILLEGAL'      :(READ)                03050000
INCX     X = X + 1                               :($SWITCH1)            03060000
FIRST    SWITCH1 = .SEARCH                                              03070000
F1       CARD LEN(1) . CH =                      :F(ERR)                03080000
         HEAD = SYMB(CH)                                                03090000
         CURRENT = HEAD                                                 03100000
F2       CARD LEN(1) . CH =                      :F(INSERT)             03110000
F3       SUCC(CURRENT) = SYMB(CH,CURRENT)                               03120000
         CURRENT = SUCC(CURRENT)                 :(F2)                  03130000
INSERT   ASSOC(CURRENT) = ASSOC(CURRENT) X ","   :(READ)                03140000
SEARCH   CARD LEN(1) . CH =                      :F(ERR)                03150000
         LGT(CHAR(HEAD), CH)                     :S(S7)                 03160000
         IDENT(CHAR(HEAD),CH)                    :S(S5)                 03170000
*                                                                       03180000
*  FIRST CHARACTER OF HEAD IS < FIRST CHAR OF CHAR JUST READ            03190000
*  IF ALT(HEAD) NULL THEN MUST EXTEND STRUCTURE                         03200000
*                                                                       03210000
         IDENT(ALT(HEAD))                        :S(S3)                 03220000
         CURRENT = ALT(HEAD)                                            03230000
S1       LGT(CHAR(CURRENT),CH)                   :S(S6)                 03240000
         IDENT(CHAR(CURRENT),CH)                 :S(S4)                 03250000
         IDENT(ALT(CURRENT))                     :S(S2)                 03260000
         CURRENT = ALT(CURRENT)                  :(S1)                  03270000
*                                                                       03280000
*  NEW ALTERNATIVE MUST BE INSERTED AT END                              03290000
*                                                                       03300000
S2       ALT(CURRENT) = SYMB(CH,CURRENT)                                03310000
*                                                                       03320000
*  THEN REST OF WORD STRUNG OUT                                         03330000
*                                                                       03340000
         CURRENT = ALT(CURRENT)                  :(F2)                  03350000
*                                                                       03360000
*  NEW ALTERNATIVE MUST BE INSERTED AT HEAD OF LIST                     03370000
*                                                                       03380000
S3       ALT(HEAD) = SYMB(CH,HEAD)                                      03390000
         CURRENT = ALT(HEAD)                     :(F2)                  03400000
-EJECT                                                                  03410000
*                                                                       03420000
*  CHARACTER HAS BEEN FOUND. NOW LOOK AT NEXT HCARACTER OF WORD         03430000
*                                                                       03440000
S4       CARD LEN(1) . CH  =                     :F(INSERT)             03450000
*  IF NO SUCCESSORS, STRING OUT REST OF WORD                            03460000
*                                                                       03470000
         IDENT(SUCC(CURRENT))                    :S(F3)                 03480000
*                                                                       03490000
*  OTHERWISE CONTINUE EXAMINATION                                       03500000
*                                                                       03510000
         CURRENT = SUCC(CURRENT)                 :(S1)                  03520000
S5       CURRENT = HEAD                          :(S4)                  03530000
*                                                                       03540000
*  CHAR IS SMALLER THAN CURRENT ALTERNATIVE                             03550000
*                                                                       03560000
S6       Y = LINK(CURRENT)                                              03570000
         ALT(Y) = IDENT(ALT(Y),CURRENT) SYMB(CH,Y)         :F(S6A)      03580000
         Y = ALT(Y)                              :(S6B)                 03590000
S6A      SUCC(Y) = SYMB(CH,Y)                                           03600000
         Y = SUCC(Y)                                                    03610000
S6B      ALT(Y) = CURRENT                                               03620000
         LINK(CURRENT) = Y                                              03630000
         CURRENT = Y                             :(F2)                  03640000
*                                                                       03650000
*  NEW ALTERNATIVE MUST BE LINKED TO HEAD, AT TOP OF LIST               03660000
*                                                                       03670000
S7       Y = HEAD                                                       03680000
         HEAD = SYMB(CH)                                                03690000
         LINK(Y) = HEAD                                                 03700000
         ALT(HEAD) = Y                                                  03710000
         CURRENT = HEAD                          :(F2)                  03720000
CONTROL  IDENT(CARD,"*")                         :F(C1)                 03730000
         OUTPUT =                                                       03740000
         OUTPUT = '  (STRUCTURE IS CLEARED)'                            03750000
         OUTPUT =                                :(CLEAR)               03760000
C1       IDENT(CARD,'$')                         :F(C2)                 03770000
         OUTPUT =                                                       03780000
         OUTPUT = '  (PRINTOUT OF ENTIRE STRUCTURE FOLLOWS...)'         03790000
         OUTPUT =                                                       03800000
         IDENT(HEAD)                             :S(C4)                 03810000
         HOLD =                                                         03820000
         START = HEAD                            :(LISTEM)              03830000
C2       IDENT(CARD)                             :S(BADCARD)            03840000
         CARD NOTANY(ALPH)                       :S(BADCARD)            03850000
-EJECT                                                                  03860000
*                                                                       03870000
*  HERE TO PRINT WORDS STARTING WITH SPECIFIED HEAD                     03880000
*                                                                       03890000
         OUTPUT =                                                       03900000
         OUTPUT = '  (PRINTOUT OF ALL WORDS BEGINNING WITH "'           03910000
+          CARD '"...)'                                                 03920000
         OUTPUT =                                                       03930000
         HOLD = CARD                                                    03940000
         CURRENT = HEAD                                                 03950000
         CARD LEN(1) . CH =                                             03960000
C3       IDENT(CHAR(CURRENT),CH)                 :S(NEXT)               03970000
         CURRENT = ALT(CURRENT)                                         03980000
         IDENT(CURRENT)                          :F(C3)                 03990000
C4       OUTPUT = '  (NO WORDS)'                 :(READA)               04000000
NEXT     CARD LEN(1) . CH =                      :F(SETUP)              04010000
         CURRENT = SUCC(CURRENT)                                        04020000
         IDENT(CURRENT)                          :S(C4)F(C3)            04030000
SETUP    OUTPUT = DIFFER(ASSOC(CURRENT)) SPC HOLD '  ' ASSOC(CURRENT)   04040000
         START = DIFFER(SUCC(CURRENT)) SUCC(CURRENT)  :F(C4)            04050000
LISTEM   N = 0                                                          04060000
         CURRENT = START                                                04070000
L1       HOLD = HOLD CHAR(CURRENT)                                      04080000
L2       OUTPUT = DIFFER(ASSOC(CURRENT)) SPC HOLD '  ' ASSOC(CURRENT)   04090000
         CURRENT = DIFFER(SUCC(CURRENT)) SUCC(CURRENT)  :S(L1)          04100000
BACKUP   CURRENT = DIFFER(ALT(CURRENT)) ALT(CURRENT)  :F(B1)            04110000
         N = N + 1                                                      04120000
         $('STACK' N) = LINK(CURRENT)                                   04130000
         HOLD LEN(1) RPOS(0) = CHAR(CURRENT)     :(L2)                  04140000
B1       Y = LINK(CURRENT)                                              04150000
         IDENT(Y)                                :S(READA)              04160000
         IDENT(Y,START) IDENT(ALT(Y),CURRENT)    :S(READA)              04170000
         IDENT(Y,START) IDENT(ALT(Y))            :S(READA)              04180000
         CURRENT = Y                                                    04190000
         HOLD DIFFER($('STACK' N),Y)  LEN(1) RPOS(0) =  :S(BACKUP)      04200000
         N = N - 1                               :(B1)                  04210000
END1     OUTPUT =                                                       04220000
         OUTPUT = '(ALL DATA PROCESSED)'                                04230000
END                                                                     04240000
ABC                                                                     04250000
ABCD                                                                    04260000
ABCDE                                                                   04270000
BCDEF                                                                   04280000
$$                                                                      04290000
$*                                                                      04300000
ELASTIC                                                                 04310000
HAPPILY                                                                 04320000
BOX                                                                     04330000
FOX                                                                     04340000
CARS                                                                    04350000
GAITERS                                                                 04360000
ALL                                                                     04370000
DUMP                                                                    04380000
JUNE                                                                    04390000
IN                                                                      04400000
$$                                                                      04410000
$*                                                                      04420000
SISTER                                                                  04430000
SUSIE                                                                   04440000
SELLS                                                                   04450000
SEA                                                                     04460000
SHELLS                                                                  04470000
BY                                                                      04480000
THE                                                                     04490000
SEA                                                                     04500000
SHORE                                                                   04510000
$$                                                                      04520000
$S                                                                      04530000
$SH                                                                     04540000
SOME                                                                    04550000
SEA                                                                     04560000
SHELLS                                                                  04570000
SEND                                                                    04580000
SAILORS                                                                 04590000
SWIMMING                                                                04600000
$$                                                                      04610000
$S                                                                      04620000
$SE                                                                     04630000
$*                                                                      04640000
$$                                                                      04650000
CATTLE                                                                  04660000
CARP                                                                    04670000
CAT                                                                     04680000
GORGE                                                                   04690000
MONSTER                                                                 04700000
MONEY                                                                   04710000
CAR                                                                     04720000
DOG                                                                     04730000
METAL                                                                   04740000
CAVE                                                                    04750000
CAKE                                                                    04760000
CAT                                                                     04770000
$$                                                                      04780000
$MON                                                                    04790000
$M                                                                      04800000
$C                                                                      04810000
$CA                                                                     04820000
$CAT                                                                    04830000
$CATT                                                                   04840000
$CAX                                                                    04850000
$$                                                                      04860000
./*                                                                     04870000
//                                                                      04880000